////////////////////////////////////////////////////////////////////////////////
//Company: 
//Engineer:
//
//Create Date:   13:44:53 11/01/2013
//Design Name:   tdr_ucl_wrapper
//Module Name:   E:/Projects/ISE3/tdr_ucl_wrapper/tb_tdr_ucl_wrapper.v
//Project Name:  tdr_ucl_wrapper
//Target Device:  
//Tool versions:  
//Description: 
//
//Verilog Test Fixture created by ISE for module: tdr_ucl_wrapper
//
//Dependencies:
//
//Revision:
//Revision 0.01 - File Created
//Additional Comments:
//
////////////////////////////////////////////////////////////////////////////////

//cd /home/UFAD/tonyhe/sa/aes_core_54/sim_sa_rtl/
//vcs -full64 ../design_sa_rtl/*.v -R -debug_all +v2k +incdir+../design_sa_rtl/ -l log.txt
//vcs -full64 ../design_sa_rtl/*.v -R -debug_all -gui +v2k +incdir+../design_sa_rtl/ -l log.txt

`timescale 1ns / 10ps

module tb_top;

//=======================================================

parameter SYS_PERIOD            = 10,      //clk 100M, 10ns
KeyBits 		  = 128,		
DataBits 		  = 128;



//=======================================================

//interface to top
//Inputs
reg [31:0] NUM_PLAINTEXT;
reg [31:0] RUN;

reg [KeyBits-1:0] Kin;
reg [DataBits-1:0] Din;
reg Krdy;
reg Drdy;
reg RSTn;
reg EN;
reg CLK;

//Outputs

wire [DataBits-1:0] Dout;
wire BSY;
wire Kvld;
wire Dvld;

//Internal Signals

integer i;
reg [DataBits-1:0] EXOR;

integer fd;
integer fd1;
integer fd2;
integer count=0;
reg[399:0] string1;
integer seed;
integer temp;


AES_Comp_ENC uut(
.CLK(CLK),
.RSTn(RSTn),
.Kin(Kin),
.Din(Din),
.Krdy(Krdy),
.Drdy(Drdy),
.EN(EN),
.Dout(Dout),
.BSY(BSY),
.Kvld(Kvld),
.Dvld(Dvld)
);

//=======================================================

initial begin
	if (! $value$plusargs("NUM_PLAINTEXT=%d", NUM_PLAINTEXT)) begin
	  $display("ERROR: please specify +NUM_PLAINTEXT=<value> to start.");
	  $finish;
  	end

	if (! $value$plusargs("RUN=%d", RUN)) begin
	  $display("ERROR: please specify +RUN=<value> to start.");
	  $finish;
  	end

	CLK = 0;
	forever
	#(SYS_PERIOD/2) CLK = ~CLK;
end

initial begin
	$sformat(string1,"AES_GF_%0d_%0d.vcd",NUM_PLAINTEXT, RUN);
	$dumpfile(string1);
	$dumpvars(0,tb_top.uut);
end

initial begin
	fd=$fopen("./design_sa_rtl/key.txt","r");	
	$fscanf(fd,"%h",Kin);

	fd1=$fopen("./design_sa_rtl/pt.txt","r");	

	for (i = 0; i < NUM_PLAINTEXT; i = i+1) begin
		RSTn = 0;
		EN = 0;
		Krdy = 0;
		Drdy = 0;

		#(SYS_PERIOD) RSTn = 1;
		EN = 1;	

		#SYS_PERIOD Krdy = 1;
		#(SYS_PERIOD) Krdy = 0;

		$fscanf(fd1,"%h",Din);

		#SYS_PERIOD Drdy = 1;


		while (~Dvld) begin
			#(SYS_PERIOD);		
		end

		@(negedge CLK);

	end

	$display("Key input:         %h", Kin);
	$display("Data input:        %h", Din);
	$display("Data output:       %h", Dout);
	$display("Busy signal:       %h", BSY);
	$display("Key valid:         %h", Kvld);
	$display("Data output valid: %h", Dvld);

	// 		exit simulation
	$finish;
end

//=======================================================

endmodule
