////////////////////////////////////////////////////////////////////////////////
//Company: 
//Engineer:
//
//Create Date:   13:44:53 11/01/2013
//Design Name:   tdr_ucl_wrapper
//Module Name:   E:/Projects/ISE3/tdr_ucl_wrapper/tb_tdr_ucl_wrapper.v
//Project Name:  tdr_ucl_wrapper
//Target Device:  
//Tool versions:  
//Description: 
//
//Verilog Test Fixture created by ISE for module: tdr_ucl_wrapper
//
//Dependencies:
//
//Revision:
//Revision 0.01 - File Created
//Additional Comments:
//
////////////////////////////////////////////////////////////////////////////////

//cd /home/UFAD/tonyhe/sa/aes_core_64/sim_sa_rtl/
//vcs -full64 ../design_sa_rtl/*.v -R -debug_all -sverilog +v2k +incdir+../design_sa_rtl/ -l log.txt
//vcs -full64 ../design_sa_rtl/*.v -R -debug_all -gui +v2k +incdir+../design_sa_rtl/ -l log.txt

`timescale 1ns / 10ps

module tb_top;

  //=======================================================

  parameter SYS_PERIOD            = 10,      //clk 100M, 10ns
	    KeyBits 		  = 128,		
	    DataBits 		  = 128;

	  
                      
  //=======================================================

  //interface to top
  //Inputs
  reg [31:0] NUM_PLAINTEXT;
  reg [31:0] RUN;
  reg [KeyBits-1:0] key_in;
  reg [DataBits-1:0] text_in;
  reg enc_dec;
  reg key_exp;
  reg start;
  reg resetn;
  reg clock;
  //reg [383:0] random_bits;

  //Outputs

  wire [DataBits-1:0] text_out;
  wire busy;
  wire key_val;
  wire text_val;

  integer i;
  reg [DataBits-1:0] text_in_display;
  
  integer fd;
  integer fd1;
  integer count=0;
  reg[399:0] string1;
  integer seed;
  integer temp;

  //ISE does not send warning/error, if some ports are missed within UUT,
  //therefore, strongly suggest recreating testbench once new modules are added,
  //or ports within modules are changed

  //Instantiate the Unit Under Test (UUT)
	
  aes128_table_ecb uut(
          .clock(clock),
          .resetn(resetn),
          .key_in(key_in),
          .text_in(text_in),
          .enc_dec(enc_dec),
          .key_exp(key_exp),
          .start(start),
          .text_out(text_out),
          .busy(busy),
          .key_val(key_val),
          .text_val(text_val)
          );
  
  //=======================================================

initial begin
	if (! $value$plusargs("NUM_PLAINTEXT=%d", NUM_PLAINTEXT)) begin
	  $display("ERROR: please specify +NUM_PLAINTEXT=<value> to start.");
	  $finish;
  	end

	if (! $value$plusargs("RUN=%d", RUN)) begin
	  $display("ERROR: please specify +RUN=<value> to start.");
	  $finish;
  	end

	clock = 0;
	forever
	#(SYS_PERIOD/2) clock = ~clock;
end

initial begin
	$sformat(string1,"AES_LUT_%0d_%0d.vcd",NUM_PLAINTEXT, RUN);
	$dumpfile(string1);
	$dumpvars(0,tb_top.uut);
end


initial begin


fd=$fopen("./design_sa_rtl/key.txt","r");
fd1=$fopen("./design_sa_rtl/pt.txt","r");		
$fscanf(fd,"%h",key_in);

for (i = 0; i < NUM_PLAINTEXT; i = i+1) begin
	resetn = 0;
	enc_dec = 0;
	key_exp = 0;
	start = 0;
			
	#(SYS_PERIOD*3) resetn = 1;
	start = 1;


	$fscanf(fd1,"%h",text_in);

	#(SYS_PERIOD*11);

	while (~text_val) begin
		#(SYS_PERIOD);			
	end
	//#(SYS_PERIOD*3);
	@(negedge clock);		

end //for loop end

$display("Key input:         %h", key_in);
$display("Data input:        %h", text_in);
$display("Data output:       %h", text_out);
$display("Busy signal:       %h", busy);
$display("Key valid:         %h", key_val);
$display("Data output valid: %h", text_val);

// 		exit simulation
#SYS_PERIOD $finish;
end

//=======================================================

endmodule
