from PowerAnalyzePersistent import PowerAnalyzePersistent
import numpy
import os
import random
import csv
import shutil
#from sklearn.preprocessing import MinMaxScaler, Normalizer
#from scipy.spatial import distance

import time
start_time = time.time()


Project_name = "AES_GF"
project_dir = os.path.join("..",Project_name)
timeperiod = 30 #for AES_GF
#timeperiod = 50 #for AES_LUT

metric = 'KL' 
#metric = 'JS'
#metric = 'ttest'
num_pt = 1000

#Select Keypair 1,2,3,4,5
#1: (Random Key Pair,
#2:("00"*16, "FF"*16),
#3: ("11"*16, "EE"*16),
#4: ("33"*16, "CC"*16),
#5: ("77"*16, "88"*16)

keypair = PowerAnalyzePersistent.GenerateKeyPairs(2)

seed = False

VCD1 = os.path.join(project_dir,Project_name+'_'+str(num_pt)+"_1.vcd")
VCD2 = os.path.join(project_dir,Project_name+'_'+str(num_pt)+"_2.vcd")

if os.path.exists(VCD1):
    print("VCD Simulation Already Exists")
else:
    print("Performing Simulation to dump VCD Files")
    os.chdir(project_dir)
    keypath = os.path.join('design_sa_rtl','key.txt')
    with open(keypath,"w") as fp:
        fp.write(keypair[0])

    #generate vcd file
    if seed:
        command = os.path.join('./generate_vcd.sh') + " -n " + str(num_pt) + " -r " + str(1) + " -s 1"
    else:   
        command = os.path.join('./generate_vcd.sh') + " -n " + str(num_pt) + " -r " + str(1)
    os.system(command)
    os.chdir(os.path.join('..','Analysis_scripts'))

if os.path.exists(VCD2):
    print("VCD Simulation Already Exists")
else:
    print("Performing Simulation to dump VCD Files")
    os.chdir(project_dir)
    keypath = os.path.join('design_sa_rtl','key.txt')
    with open(keypath,"w") as fp:
        fp.write(keypair[1])

    #generate vcd file
    if seed:
        command = os.path.join('./generate_vcd.sh') + " -n " + str(num_pt) + " -r " + str(2) + " -s 2"
    else:  
        command = os.path.join('./generate_vcd.sh') + " -n " + str(num_pt) + " -r " + str(2)
    os.system(command)
    os.chdir(os.path.join('..','Analysis_scripts'))


traces1 = PowerAnalyzePersistent(project_dir, name='traces1',num_plaintext=num_pt)
traces1.set_timeperiod(timeperiod)
traces1.set_vcdPath(VCD1)
traces1.create_VCDDumpMap()


traces2 = PowerAnalyzePersistent(project_dir, name='traces2',num_plaintext=num_pt)
traces2.set_timeperiod(timeperiod)
traces2.set_vcdPath(VCD2)
traces2.create_VCDDumpMap()


#Select the modules for analysis
#Default it selects all the modules in the maps
modules = list(traces1.module_map.keys())

Distance = {}
Distance_p = {}
for module in modules:

    trace1 = traces1.get_SAtraces(module, clean=False)
    trace2 = traces2.get_SAtraces(module, clean=False)

    """
    scaler = Normalizer()
    scaler.fit(numpy.vstack((trace1,trace2)))
    trace1 = scaler.transform(trace1)
    trace2 = scaler.transform(trace2)
    """

    if metric == 'KL':
        d = PowerAnalyzePersistent.KL_Divergence(trace1,trace2)
    elif metric == 'JS':
        d = PowerAnalyzePersistent.Jensen_Shannon(trace1,trace2)
    elif metric == 'ttest':
        d,p = PowerAnalyzePersistent.t_test(trace1,trace2)
    
    Distance[module] = d
    if metric == 'ttest':
        Distance_p[module] = p


filename = os.path.join(os.path.abspath(project_dir), metric+ '_SA_' + str(num_pt) + '.csv')
#filename = os.path.join(os.path.abspath(project_dir),'subkey10', metric+ '_SA_' + str(num_pt) + '.csv')
PowerAnalyzePersistent.save_metric_dict(Distance,filename)

if metric=='ttest':
    filename = os.path.join(os.path.abspath(project_dir), metric+ '_pvalues_SA_' + str(num_pt) + '.csv')
    #filename = os.path.join(os.path.abspath(project_dir),'subkey10', metric+ '_SA_' + str(num_pt) + '.csv')
    PowerAnalyzePersistent.save_metric_dict(Distance_p,filename)

#shutil.rmtree(os.path.join(project_dir,'maps_1000'))
##os.remove(VCD1)
#os.remove(VCD2)
#os.remove(VCD1+'.txt')
#os.remove(VCD2+'.txt')

print(Distance)
print("done")
print("--- %s seconds ---" % (time.time() - start_time))
